unit viswnd;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,winamp_vis,
  Menus,Registry ;

const
   WaveArrCount = 24;
   CfgKey = 'Software/Skynet/DenVis1.1';

type
  TKfar = Array [ 1 .. 10] of byte;
  TWavesArr = Array [ 1 .. WaveArrCount] of PByteArray;

  TBlurMaskArray = Array [0 ..0] of TKFar;
  PBlurMaskArray = ^TBlurMaskArray;

  TViswind = class(TForm)
    PopupMenu1: TPopupMenu;
    Variate1: TMenuItem;
    N1: TMenuItem;
    Blur1: TMenuItem;
    Red1: TMenuItem;
    Green1: TMenuItem;
    Blue1: TMenuItem;
    BlueSpectrum1: TMenuItem;
    GreenSpectrum1: TMenuItem;
    Redwafveform1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    Size1: TMenuItem;
    x11: TMenuItem;
    x21: TMenuItem;
    FullScreen1: TMenuItem;
    SongName1: TMenuItem;
    WinampLike1: TMenuItem;
    RunMasking1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Red1Click(Sender: TObject);
    procedure x21Click(Sender: TObject);
    procedure x11Click(Sender: TObject);
    procedure FullScreen1Click(Sender: TObject);
    procedure WinampLike1Click(Sender: TObject);
  private
    { Private declarations }
    IMs:DWORD;
    IHs:DWORD;
    bmpInf:pchar;
    bmpImg:pointer;
    Rchannel,GChannel,BChannel:pointer;
    Rchannel1,GChannel1,BChannel1:pointer;
    Rchannel2,GChannel2,BChannel2:pointer;
    Bmp:TBitMap;
    kf:TKfar;
    wdth:Integer;
    binf,binf1:tagBITMAPINFO;

    GL,Bl,RL:byte;
    gten,bten,rten:byte;
    gten1,bten1,rten1:byte;

    bc,bcc:Integer;


    Per:word;
    wtext:PChar;
    WArr:TWavesArr;
    CWArrIdx:Integer;

    fmap:THandle;
    pbma,pbma1,pbma2:PBlurMaskArray;

    procedure initKF;
    procedure variate;
  public
    { Public declarations }
    module:PwinampVisModule;
    procedure render;
  end;

 TQUADARR = array [0 ..0] of tagRGBQUAD ;





var
  Viswind: TViswind;
  modulle:PwinampVisModule;

implementation

{$R *.DFM}
const
//   Kfc : TKfar = ( 1,1,1,1,1,1,1,1,1,7);

 Kfc : TKfar = ( 1,1,1,1,16,16,16,1,5,58);
 Kfc1: TKfar = ( 16,16,16,1,1,1,1,1,5,58);
 Kfc2 : TKfar = ( 32,32,32,1,32,32,32,1,5,202);
 KfcNorm:TKfar = ( 1,1,1,1,1,1,1,1,1,8);

 Kff1:TKfar = ( 16,8,8,0,0,0,8,8,0, 43);
 Kff12:TKfar =( 8,16,8,8,0,0,0,8,0, 43);
 Kff2:TKfar = ( 8,8,16,8,8,0,0,0,0, 43);
 Kff23:TKfar =( 0,8,8,16,8,8,0,0,0, 43);
 Kff3:TKfar = ( 8,0,0,0,8,8,16,8,0, 43);
 Kff34:TKfar =( 8,8,0,0,0,8,8,16,0, 43);
 Kff4:TKfar = ( 0,0,8,8,16,8,8,0,0, 43);
 Kff41:TKfar =( 0,0,0,8,8,16,8,8,0, 43);

function cut(W:Word):byte;
begin
  //if W>255 then result:=255 - (W mod 255)
          { else} result:=byte(W);
end;



procedure blurbar(B,B1:PByteArray;len,w:Integer; Kf:TKfar);
var
  i,j,k,segm:Integer;
  krv,krov,Mv,Mng:Integer;
begin
 segm:=W;
 krov:=1;
 krv:=1;
 Mv:=10;
 Mng:=krov*4+krv*4+Mv-5;

 for i:=1 to (w-1) do B1[i]:=cut((B[i-1]*kf[8] + B[i]*kf[9] + B[i+1]* kf[4] + B[i+W-1]*kf[7] + B[i+W] * kf[6] +B[i+W+1]*kf[5] )div kf[10] ){ and 31};

 for k:=1 to (len div W)-2 do
 begin
 for i:=1 to (W-1) do
  begin
    j:=segm+i;
    B1[j]:=cut((B[j-1]*kf[8] + B[j]*kf[9] + B[j+1]* kf[4] + B[j-W-1] * Kf[1] + B[j-W]* kf[2] + B[j-W +1]*kf[3] +B[j+W-1]*kf[7] + B[j+W] * kf[6] +B[j+W+1]*kf[5] )div kf[10]){ and 31};
  end;
   segm:=segm+W;
  end;
 for i:=1 to (w-1) do
   begin
   j:= segm+i;
   B1[j]:=cut((B[j-1]*kf[8] + B[j]*kf[9] + B[j+1]* kf[4] + B[j-W-1] * Kf[1] + B[j-W]* kf[2] + B[j-W +1]*kf[3] )div kf[10]){ and 31};
   end;
end;


procedure blurbarby4(B,B1:PByteArray;len,w:Integer; Kf1,Kf2,Kf3,Kf4:TKfar);
var
  i,j,k,segm:Integer;
  krv,krov,Mv,Mng:Integer;
begin
 segm:=W;
 krov:=1;
 krv:=1;
 Mv:=10;
 Mng:=krov*4+krv*4+Mv-5;

 for i:=1 to (w div 2) do B1[i]:=cut((B[i-1]*kf1[8] + B[i]*kf1[9] + B[i+1]* kf1[4] + B[i+W-1]*kf1[7] + B[i+W] * kf1[6] +B[i+W+1]*kf1[5] )div kf1[10]){ and 31};
 for i:=(w div 2)+1 to (w-1) do B1[i]:=cut((B[i-1]*kf2[8] + B[i]*kf2[9] + B[i+1]* kf2[4] + B[i+W-1]*kf2[7] + B[i+W] * kf2[6] +B[i+W+1]*kf2[5] )div kf2[10]){ and 31};

 for k:=1 to (len div (W*2)) do
 begin
 for i:=1 to (W div 2) do
  begin
    j:=segm+i;
    B1[j]:=cut((B[j-1]*kf1[8] + B[j]*kf1[9] + B[j+1]* kf1[4] + B[j-W-1] * Kf1[1] + B[j-W]* kf1[2] + B[j-W +1]*kf1[3] +B[j+W-1]*kf1[7] + B[j+W] * kf1[6] +B[j+W+1]*kf1[5] )div kf1[10]) {and 31};
  end;
  for i:=(W div 2)+1 to (W-1) do
  begin
    j:=segm+i;
    B1[j]:=cut((B[j-1]*kf2[8] + B[j]*kf2[9] + B[j+1]* kf2[4] + B[j-W-1] * Kf2[1] + B[j-W]* kf2[2] + B[j-W +1]*kf2[3] +B[j+W-1]*kf2[7] + B[j+W] * kf2[6] +B[j+W+1]*kf2[5] )div kf2[10]) {and 31};
  end;
  segm:=segm+W;
 end;


 for k:=len div (W*2)+1 to (len div W)-2 do
 begin
 for i:=1 to (W div 2) do
  begin
    j:=segm+i;
    B1[j]:=cut((B[j-1]*kf3[8] + B[j]*kf3[9] + B[j+1]* kf3[4] + B[j-W-1] * Kf3[1] + B[j-W]* kf3[2] + B[j-W +1]*kf3[3] +B[j+W-1]*kf3[7] + B[j+W] * kf3[6] +B[j+W+1]*kf3[5] )div kf3[10]){ and 31};
  end;
  for i:=(W div 2)+1 to (W-1) do
  begin
    j:=segm+i;
    B1[j]:=cut((B[j-1]*kf4[8] + B[j]*kf4[9] + B[j+1]* kf4[4] + B[j-W-1] * Kf4[1] + B[j-W]* kf4[2] + B[j-W +1]*kf4[3] +B[j+W-1]*kf4[7] + B[j+W] * kf4[6] +B[j+W+1]*kf4[5] )div kf4[10]){ and 31};
  end;


   segm:=segm+W;
  end;

 for i:=1 to (w div 2) do
   begin
   j:= segm+i;
   B1[j]:=cut((B[j-1]*kf3[8] + B[j]*kf3[9] + B[j+1]* kf3[4] + B[j-W-1] * Kf3[1] + B[j-W]* kf3[2] + B[j-W +1]*kf3[3] )div kf3[10]){ and 31};
   end;

  for i:=(w div 2)+1 to (w-1) do
   begin
   j:= segm+i;
   B1[j]:=cut((B[j-1]*kf4[8] + B[j]*kf4[9] + B[j+1]* kf4[4] + B[j-W-1] * Kf4[1] + B[j-W]* kf4[2] + B[j-W +1]*kf4[3] )div kf4[10]) {and 31};
   end;

end;


procedure blurbrbymask(B,B1:PByteArray;len,w:Integer; mask:PBlurMaskArray);


var
  i,j,k,segm:Integer;
  krv,krov,Mv,Mng:Integer;
begin
 segm:=W;
 krov:=1;
 krv:=1;
 Mv:=10;
 Mng:=krov*4+krv*4+Mv-5;

 for i:=1 to (w-1) do
  B1[i]:=((B[i-1]*mask^[i][8] + B[i]*mask^[i][9] + B[i+1]* mask^[i][4] + B[i+W-1]*mask^[i][7] + B[i+W] * mask^[i][6] +B[i+W+1]*mask^[i][5] )div mask^[i][10] ){ and 31};

 for k:=1 to (len div W)-2 do
 begin
 for i:=1 to (W-1) do
  begin
    j:=segm+i;
    B1[j]:=((B[j-1]*mask^[j][8] + B[j]*mask^[j][9] + B[j+1]* mask^[j][4] + B[j-W-1] * mask^[j][1] + B[j-W]* mask^[j][2] + B[j-W +1]*mask^[j][3] +B[j+W-1]*mask^[j][7] + B[j+W] *mask^[j][6] +B[j+W+1]*mask^[j][5] )div mask^[j][10]){ and 31};
  end;
   segm:=segm+W;
  end;
 for i:=1 to (w-1) do
   begin
   j:= segm+i;
   B1[j]:=((B[j-1]*mask^[j][8] + B[j]*mask^[j][9] + B[j+1]* mask^[j][4] + B[j-W-1] * mask^[j][1] + B[j-W]* mask^[j][2] + B[j-W +1]*mask^[j][3] )div mask^[j][10]){ and 31};
   end;
end;

procedure orbr(A,B:PByteArray;Len:Integer);
var i:Integer;
begin
 for i:=0 to (len-1) do A[i]:=A[i] or B[i];
end;

procedure orwr(A,B:PWordArray;Len:Integer);
var i:Integer;
begin
 for i:=0 to (len-1) do A[i]:=A[i] or B[i];
end;

procedure andwr(A,B:PByteArray;Len:Integer);
var i:Integer;
begin
 for i:=0 to (len-1) do A[i]:=A[i] and B[i];
end;

procedure Mix(R,G,B:PByteArray;Img:PByteArray;Len:Integer);
var i:Integer;
begin
  for i:=0 to (len-1) do
    begin
    Img[i*3]:=R[i];
    Img[i*3+1]:=G[i];
    Img[i*3+2]:=B[i];
    end;
end;

procedure GetChannel(Br:PByteArray;Wr:PByteArray;len:integer;Idx:word);
var i:Integer;
begin
 for i:=0 to (len-1) do
   br[i]:=wr[i*3+Idx];
end;

procedure MakeWaves(A:PByteArray; Len,W,Period,Level,Fola:Integer;Faza:Real);
var
 I,k:Integer;
 B:Real;
 alfa,al1,al2:Word;
begin
 for k:=0 to (Len div w - 1) do
 begin
 for i:=0 to (w-1) do
 begin
  case Fola of
   1:begin
     if i<128 then Faza:=-Abs(Faza) else Faza:=Abs(Faza);
     //if (period+(i-128) / 5)<>0 then
     B:=Level*3/4-Abs(Len /w/2 - k)/(Len /w/2)*(Level*3/4) +(Level/4)*sin(2*pi*(i-128)/(period+Abs(Len /w/2 -k))+Faza);
    // else B:=0;

     end;
   2: begin
    if i<128 then Faza:=-Abs(Faza) else Faza:=Abs(Faza);
    if (period+(i-128) / 5)<>0 then
    B:=Level*3/4-Abs(Len /w/2 - k)/(Len /w/2)*(Level*3/4) +(Level/4)*sin(2*pi*(i-128)/(period+(i-128) / 5)+Faza)
    else B:=0;
    end;

    end;

//  B:=15+15*sin(2*pi*i/(period+i / 5)+Faza);
  if B>0 then  alfa:=Trunc(B) else alfa:=0;
 { if B<=0 then Alfa:=0;
  if (B>0) and (B<=1) then Alfa:=1;
  if (B>1) and (B<=3) then Alfa:=3;
  if (B>3) and (B<=7) then Alfa:=7;
  if (B>7) and (B<=15) then Alfa:=15;
  if (B>15) then Alfa:=31;}
 // Alfa:=Trunc(b);
  A[k*W*3+i*3]:=alfa;
  A[k*W*3+i*3+1]:=alfa;
  A[k*W*3+i*3+2]:=alfa;
 end;
 end;

end;

procedure MakeWavesArr(Var A:TWavesArr;Len,W:Integer);
var I :Integer;
    fl:Integer;
begin
  fl:=TRunc(random*2+1);
  for i:=1 to WaveArrCount do
   begin
   GetMem(A[i],Len*3);
   MakeWaves(A[i],Len,W,1,255,fl,(i-1)/(WaveArrCount)*2*pi);
   end;
end;

procedure MakeRndBma(var A:PBlurMaskArray;Len:Integer;Max:Integer);
 var
    i,j:Integer;
    S:Integer;
begin
 GetMem(A,Len*SizeOf(TKfar));
 for i:=0 to (Len-1) do
  begin
  S:=0;
  for j:=1 to 9 do
   begin
     A[i][j]:=Trunc(random*Max);
   //  A[i][j]:=Trunc(Max/2+(Max/2)*sin((i+j)*2*pi/9)/2);
     S:=S+A[i][j];
   end;
    if S=0 then S:=1;
    A[i][10]:=S+1;
   end;
end;


procedure MakeSpiralBma(var A:PBlurMaskArray;Len:Integer;Max,w:Integer);
 var
    i,j,x,y,sx,sy,mk:Integer;
    S:Integer;
    u:Real;
   // F:TextFile;
    Ra:Array [1 ..9] of real;
begin
 GetMem(A,Len*SizeOf(TKfar));
 //AssignFile(F,'Check');
// Rewrite(F);
 for i:=0 to (Len-1) do
  begin
  S:=0;
  x:=i mod w;
  y:=i div w;
  sx:=w div 2-1;
  sy:=len div w div 2 -1;
  U:=Max/2+Max*cos((x-sx-1)*pi/sx)*cos((y-sy-1)*pi/sy)/2;
  Ra[1]:=u;
  Ra[2]:=Max/2+Max*cos((x-sx)*pi/sx)*cos((y-sy-1)*pi/sy)/2;
  Ra[3]:=Max/2+Max*cos((x-sx+1)*pi/sx)*cos((y-sy-1)*pi/sy)/2;
  Ra[4]:=Max/2+Max*cos((x-sx+1)*pi/sx)*cos((y-sy)*pi/sy)/2;
  Ra[5]:=Max/2+Max*cos((x-sx+1)*pi/sx)*cos((y-sy+1)*pi/sy)/2;
  Ra[6]:=Max/2+Max*cos((x-sx)*pi/sx)*cos((y-sy+1)*pi/sy)/2;
  Ra[7]:=Max/2+Max*cos((x-sx-1)*pi/sx)*cos((y-sy+1)*pi/sy)/2;
  Ra[8]:=Max/2+Max*cos((x-sx-1)*pi/sx)*cos((y-sy)*pi/sy)/2;
  Ra[9]:=Max/2+Max*cos((x-sx)*pi/sx)*cos((y-sy)*pi/sy)/2;
  U:=0;
  for j:=1 to 9 do
   begin
     u:=U+Ra[j];
   end;
  U:=U/9;
  for j:=1 to 9 do
   begin
     Ra[j]:=Ra[j]-U;
   //  Write(F,Ra[j],',');
     if Ra[j]<0 then Ra[j]:=0;
   end;

  for j:=1 to 9 do
   begin
    while (Ra[j]<1) and (Ra[j]<>0) do Ra[j]:=Ra[j]*10;
    A[i][j]:=Trunc(Ra[j]);
   end;


  mk:=0;
  for j:=1 to 9 do
   begin
     if (A[i][j]>(Mk)) then mk:=A[i][j];
   end;

  for j:=1 to 9 do
   begin
     if (A[i][j]<>(Mk)) then A[i][j]:=1
     else A[i][j]:=8;

     S:=S+A[i][j];
   end;
    //S:=mk;
    //S:=S+2;
   // writeln(F);
   // if S=0 then S:=1;
   // A[i][10]:=S;

   end;
  // CloseFile(f);
end;

function cosSurf(x,y,max:Real):Real;
begin
 result:=Max/2+Max*cos((x)*pi/128)*cos((y)*pi/72)/2;
end;

function sfereSurf(x,y,max:Real):Real;
var a:real;
begin
 a:=sqr(128)-sqr(x)-sqr(y);
 if a>0 then result:=sqrt(a)
  else result:=0;
end;


function spirSurf(x,y,max:Real):Real;
var fi,ro,a:real;
begin

    a:=(sqr(128)-sqr(x)-sqr(y));
 if a>0 then result:=-sqrt(a)
  else result:=0;
   { if x<>0 then
    fi:=arctan(abs(y)/abs(x))
    else fi:=pi/2;
    if (x>=0) and (y>0) then fi:=fi;
    if (x<0) and (y>0) then fi:=pi-fi;
    if (x<0) and (y<0) then fi:=fi+pi;
    if (x>=0) and (y<0) then fi:=2*pi-fi;
    if (x=0) and (y=0) then fi:=0;
    ro:=sqrt(sqr(x)+sqr(y));
   // result:=20*fi*sin(ro/(1+fi/20));;
   result:=40*fi;}
end;



procedure MakeCustBma(var A:PBlurMaskArray;Len:Integer;Max,w:Integer;Fn:Integer);

 var
    i,j,x,y,sx,sy,mk:Integer;
    S:Integer;
    u,mr:Real;
   // F:TextFile;
    Ra:Array [1 ..9] of real;
    fns:function (x,y,max:Real):Real;
begin
 GetMem(A,Len*SizeOf(TKfar));
 //AssignFile(F,'Check');
// Rewrite(F);
 for i:=0 to (Len-1) do
  begin
  S:=0;
  x:=i mod w;
  y:=i div w;
  sx:=w div 2-1;
  sy:=len div w div 2 -1;
  case Fn of
          1:fns:=cosSurf;
          2:fns:=sfereSurf;
          3:fns:=spirSurf;
         end;
  Ra[1]:=fns(x-sx-1,y-sy-1,Max);
  Ra[2]:=fns(x-sx  ,y-sy-1,Max);
  Ra[3]:=fns(x-sx+1,y-sy-1,Max);
  Ra[4]:=fns(x-sx+1,y-sy  ,Max);
  Ra[5]:=fns(x-sx+1,y-sy+1,Max);
  Ra[6]:=fns(x-sx  ,y-sy+1,Max);
  Ra[7]:=fns(x-sx-1,y-sy+1,Max);
  Ra[8]:=fns(x-sx-1,y-sy ,Max);
  Ra[9]:=fns(x-sx  ,y-sy ,Max);
//  Ra[9]:=0;
  U:=0;
{  for j:=1 to 9 do
   begin
     u:=U+Ra[j];
   end;
  U:=U/9;
  for j:=1 to 9 do
   begin
     Ra[j]:=Ra[j]-U;
   //  Write(F,Ra[j],',');
     if Ra[j]<0 then Ra[j]:=0;
   end;

  for j:=1 to 9 do
   begin
    while (Ra[j]<1) and (Ra[j]<>0) do Ra[j]:=Ra[j]*10;
    A[i][j]:=Trunc(Ra[j]);
   end;}




  mr:=-1E22;
{  for j:=1 to 9 do
   begin
     if (A[i][j]>(Mk)) then mk:=A[i][j];
   end;}

  for j:=1 to 9 do
   begin
     if (Ra[j]>(Mr)) then
                      begin
                      mr:=Ra[j];
                      mk:=j;
                      end;
   end;


 // for j:=1 to 9 do
 //  begin
 //    if (A[i][j]<>(Mk)) then A[i][j]:=1
 //    else A[i][j]:=8;
 {    if A[i][j]=0 then A[i][j]:=1;
     if A[i][j]>=30 then A[i][j]:=30;
    }
//     if (Ra[j]=(Mk)) then
//      begin
      case mk of
         1:A[i]:=kff1;
         2:A[i]:=kff12;
         3:A[i]:=kff2;
         4:A[i]:=kff23;
         5:A[i]:=kff4;
         6:A[i]:=kff41;
         7:A[i]:=kff3;
         8:A[i]:=kff34;
         9:A[i]:=KfcNorm;
      end;
//       break;
//      end;

//   end;
    S:=0;
    for j:=1 to 9 do
     begin
  //   if A[i][j]=8 then A[i][j]:=0;
     S:=S+A[i][j];
     end;
    //S:=mk;
   // S:=S+1;
   // writeln(F);
  //  if S=0 then S:=1;
    A[i][10]:=S+1;

   end;
  // CloseFile(f);
end;



procedure TViswind.initKF;
begin
 kf:=kfc;
end;

procedure TViswind.FormCreate(Sender: TObject);
var
 memDC:HDC;
 Reg:TRegistry;
 Rect:TRect;
 F:TextFile;
 i,slnum:Integer;
 MsgBuf:PChar;
 binf1:Pointer;
 sa:PSecurityAttributes;

begin
 Bmp:=TBitmap.Create;
 Reg:=TRegistry.Create;
 bc:=1;
 bcc:=200;
// memDC:=CreateCompatibleDC(0);
 binf.bmiHeader.biSize:=SizeOf(tagBitMApINFOHEADER);
 binf.bmiHeader.biWidth:=width;
 binf.bmiHeader.biHeight:=height;
 binf.bmiHeader.biPlanes:=1;
 binf.bmiHeader.biBitCount:=24;
 binf.bmiHeader.biCompression:=BI_RGB;
 binf.bmiHeader.biSizeImage:=0;
 binf.bmiHeader.biXPelsPerMeter:=0;
 binf.bmiHeader.biYPelsPerMeter:=0;
 binf.bmiHeader.biClrUsed:=0;
 binf.bmiHeader.biClrImportant:=0;



// binf.bmiColors

// memDC :=  CreateCompatibleDC(0);

 fmap:=CreateFileMapping($FFFFFFFF,nil,PAGE_READWRITE,0,2000000,'denvis');
 Bmp.Handle:=//CreateCompatibleBitmap(memDC,width,height);
 //CreateBitmap(width,height,1,16,nil);
   CreateDIBSection( 0,binf,DIB_RGB_COLORS,bmpImg,fmap,0);

// ShowWindow(Handle, SW_HIDE);

 Bmp.Canvas.brush.Color:=clBlack;
 Bmp.Canvas.FillRect(Bmp.Canvas.ClipRect);
 Bmp.Canvas.Font.Color:=clWhite;
 Bmp.Canvas.Font.Size:=10;

 GetDIBSizes( Bmp.Handle,IHs,IMs);
// GetMem(bmpinf,IHs+Ims);
// bmpImg:=bmpinf+IHs;


 GetMem(RChannel,Ims div 3);
 GetMem(GChannel,Ims div 3);
 GetMem(BChannel,Ims div 3);

 GetMem(RChannel1,Ims div 3);
 GetMem(GChannel1,Ims div 3);
 GetMem(BChannel1,Ims div 3);

 GetMem(RChannel2,Ims div 3);
 GetMem(GChannel2,Ims div 3);
 GetMem(BChannel2,Ims div 3);


 //GetMem(binf1, (Ims div 2)*sizeof(tagRGBQUAD)+sizeof(tagBITMAPINFOHEADER));




 wtext:=StrAlloc(260);

  randomize;

// if not GetDIB(Bmp.Handle,Bmp.Palette,bmpinf^,bmpImg^) then
// asm
// nop;
// end;


{ if slnum<>binf.bmiHeader.biHeight then
 begin

   MsgBuf:=StrAlloc(255);
   FormatMessage(
    FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_FROM_SYSTEM,
    nil,
    GetLastError,
    LANG_ENGLISH,  // Default language
     MsgBuf,
    0,
    nil
     );

   // Display the string.
   MessageBox( 0, MsgBuf, 'GetLastError', MB_OK or MB_ICONINFORMATION );
   StrDispose(MsgBuf);

 end;}
// if not GetDIB(Bmp.Handle,Bmp.Palette,bmpInf^,bmpImg^) then ShowMessage('!!!');

// GdiFlush;
 GetChannel(RChannel,pointer(bmpImg),Ims div 3,2);
 GetChannel(GChannel,pointer(bmpImg),Ims div 3,1);
 GetChannel(BChannel,pointer(bmpImg),Ims div 3,0);
 MakeWavesArr(WArr,Ims div 3,width);
 MakeRndBma(pbma,Ims div 3,30);
 MakeCustBma(pbma1,Ims div 3,15,width,1);
 MakeCustBma(pbma2,Ims div 3,15,width,2);
 CWArrIdx:=1;

 initKf;
 wdth:=Width;


// WindowState:=wsMaximized;



 gl:=255;
 rl:=255;
 bl:=255;
 gten:=1;
 rten:=1;
 bten:=1;
 gten1:=1;
 rten1:=1;
 bten1:=1;

 if Reg.OpenKey(CfgKey,False) then
  begin
   Red1.Checked:=Reg.ReadBool('RedBlur');
   Green1.Checked:=Reg.ReadBool('GreenBlur');
   Blue1.Checked:=Reg.ReadBool('BlueBlur');
   Redwafveform1.Checked:=Reg.ReadBool('RedWaveform');
   GreenSpectrum1.Checked:=Reg.ReadBool('GreenSpectrum');
   BlueSpectrum1.Checked:=Reg.ReadBool('BlueSpaectrum');
   Variate1.Checked:=Reg.ReadBool('Variate');
   SongName1.Checked:=Reg.ReadBool('SongName');
   RunMasking1.Checked:=Reg.ReadBool('RunMasking');
   case Reg.ReadInteger('Size') of
      1:x11.Click;
      2:x21.Click;
      3:FullScreen1.Click;
      4:WinampLike1.Click;
      end;
   REg.CloseKey;
 end;

 GetWindowRect(modulle.hwndParent,Rect);
 Left:=Rect.Left;
 Top:=Rect.Bottom;
 Reg.Free;
end;

procedure Swappntrs(var A,B:Pointer);
var t:Pointer;
begin
 t:=A;
 A:=B;
 B:=t;
end;



procedure TViswind.render;
var
  x,y,wh,A:Integer;
  Rect:TRect;
  Pwr,slnum:Word;
  MsgBuf:PChar;
begin
{  for y:=0 to (module.nCh-1) do
   begin
   for x:=1 to (288) do
    begin
      Bmp.Canvas.MoveTo(128,x shr 1);
      if y=0 then
      Bmp.Canvas.LineTo((256 - module.spectrumDATA[y+1,x])shr 1,x shr 1)
       else Bmp.Canvas.LineTo((256 + module.spectrumDATA[y+1,x]) shr 1,x shr 1);
    end;
    end;}

   GetWindowRect(module.hwndParent,Rect);
   if not FullScreen1.Checked then
   begin
   Left:=Rect.Left;
   Top:=Rect.Bottom;
   end;

  if SongName1.Checked then
   begin
  if Per=0 then A:=Trunc(random*20);
  if A=2 then Per:=Trunc(random*4);
  if Per<>0 then begin
     GetWindowText(module.hwndParent,wtext,255);
     Bmp.Canvas.TextOut(128- Bmp.Canvas.TextWidth(Strpas(wtext)) div 2,60,Strpas(wtext));
  //   slnum:=GetDIBits(Bmp.Canvas.Handle ,Bmp.Handle,0,binf.bmiHeader.biHeight,bmpImg,binf,DIB_RGB_COLORS);
     if slnum<>binf.bmiHeader.biHeight then ;
// if not GetDIB(Bmp.Handle,Bmp.Palette,bInf^,bmpImg^) then ShowMessage('!!!');
     GetChannel(RChannel2,pointer(bmpImg),Ims div 3,2);
     GetChannel(GChannel2,pointer(bmpImg),Ims div 3,1);
     GetChannel(BChannel2,pointer(bmpImg),Ims div 3,0);
     Dec(Per);
   end;
   end;


  for y:=143 downto 0 do
     begin
     for x:=(128-((module.spectrumDATA[1,(144-y) shl 1]+module.spectrumDATA[1,(144-y) shl 1+1]) shr 2)) to (128+((module.spectrumDATA[2,(144-y) shl 1]+module.spectrumDATA[2,(144-y) shl 1+1]) shr 2)) do
       begin
      if BlueSpectrum1.Checked then  PByteArray(BChannel)[y*wdth+x]:=bl;
      // PByteArray(RChannel)[y*wdth+x]:=15;
      if GreenSpectrum1.Checked then  PByteArray(GChannel)[Ims div 3-(y*wdth+x)]:=gl;
       end;


    end;
  if Redwafveform1.Checked then
  for x:=0 to 256 do
    PByteArray(RChannel)[(Shortint(module.waveformData[1,x]) div 2 +72)*wdth+x]:=rl;

// bc:=8;
 case bc of
 1: begin
  if Red1.Checked then blurbar(Rchannel,Rchannel1,Ims div 3,wdth,Kfc2);

  if Green1.Checked then blurbar(Gchannel,Gchannel1,Ims div 3,wdth,Kfc1);

  if Blue1.Checked then blurbar(Bchannel,Bchannel1,Ims div 3,wdth,kfc);
  end;

 2:begin
  if Red1.Checked then blurbarby4(Rchannel,Rchannel1,Ims div 3,wdth,Kff3,kff1,kff4,kff2);

  if Green1.Checked then blurbarby4(Gchannel,Gchannel1,Ims div 3,wdth,Kff3,kff1,kff4,kff2);

  if Blue1.Checked then blurbarby4(Bchannel,Bchannel1,Ims div 3,wdth,Kff3,kff1,kff4,kff2);
  end;

3:begin

  if Red1.Checked then blurbarby4(Rchannel,Rchannel1,Ims div 3,wdth,Kff4,kff3,kff2,kff1);

  if Green1.Checked then blurbarby4(Gchannel,Gchannel1,Ims div 3,wdth,Kff4,kff3,kff2,kff1);

  if Blue1.Checked then blurbarby4(Bchannel,Bchannel1,Ims div 3,wdth,Kff4,kff3,kff2,kff1);

  end;

4:begin

  if Red1.Checked then blurbarby4(Rchannel,Rchannel1,Ims div 3,wdth,Kff4,kff3,kff2,kff1);

  if Green1.Checked then blurbarby4(Gchannel,Gchannel1,Ims div 3,wdth,Kff4,kff2,kff3,kff1);

  if Blue1.Checked then blurbarby4(Bchannel,Bchannel1,Ims div 3,wdth,Kff3,kff1,kff4,kff2);

  end;

5:begin

  if Red1.Checked then blurbrbymask(Rchannel,Rchannel1,Ims div 3,wdth,pbma);

  if Green1.Checked then blurbrbymask(Gchannel,Gchannel1,Ims div 3,wdth,pbma);

  if Blue1.Checked then blurbrbymask(Bchannel,Bchannel1,Ims div 3,wdth,pbma);

  end;

6:begin

  if Red1.Checked then blurbrbymask(Rchannel,Rchannel1,Ims div 3,wdth,pbma1);

  if Green1.Checked then blurbrbymask(Gchannel,Gchannel1,Ims div 3,wdth,pbma1);

  if Blue1.Checked then blurbrbymask(Bchannel,Bchannel1,Ims div 3,wdth,pbma1);

  end;

7:begin

  if Red1.Checked then blurbrbymask(Rchannel,Rchannel1,Ims div 3,wdth,pbma2);

  if Green1.Checked then blurbrbymask(Gchannel,Gchannel1,Ims div 3,wdth,pbma2);

  if Blue1.Checked then blurbrbymask(Bchannel,Bchannel1,Ims div 3,wdth,pbma2);

  end;

8:begin

  if Red1.Checked then blurbarby4(Rchannel,Rchannel1,Ims div 3,wdth,Kff2,kff1,kff2,kff1);

  if Green1.Checked then blurbarby4(Gchannel,Gchannel1,Ims div 3,wdth,Kff2,kff1,kff2,kff1);

  if Blue1.Checked then blurbarby4(Bchannel,Bchannel1,Ims div 3,wdth,Kff2,kff1,kff2,kff1);

  end;



  end;
  Dec(bcc);
  if bcc=0 then begin
               bc:=TRunc(random*8+1);
               bcc:=Trunc(50+Random*200);
               end;



  if Per <> 0 then begin
                    orbr(Rchannel1,Rchannel2,Ims div 3);
                    orbr(Gchannel1,Gchannel2,Ims div 3);
                    orbr(Bchannel1,Bchannel2,Ims div 3);
                   end;


  Mix(Bchannel1,GChannel1,RChannel1,pointer(bmpImg),Ims div 3);



  Swappntrs(Rchannel,Rchannel1);
  Swappntrs(Gchannel,Gchannel1);
  Swappntrs(Bchannel,Bchannel1);

  if not Red1.Checked then  FillChar(Rchannel^,Ims div 3,0);
  if not Green1.Checked then FillChar(Gchannel^,Ims div 3,0);
  if not Blue1.Checked then FillChar(Bchannel^,Ims div 3,0);

  if RunMasking1.Checked then
  begin
  andwr(pointer(bmpImg),WArr[CWArrIdx],Ims);
  inc(CWArrIdx);
  if CWArrIdx>WaveArrCount then CWArrIdx:=1;
  end;

 // slnum:=SetDIBits(Bmp.Canvas.Handle,Bmp.Handle,0,Bmp.Height,bmpImg,bInf,DIB_RGB_COLORS);
  if slnum<>Bmp.Height then
  begin
  end;



  Canvas.StretchDraw(Canvas.ClipRect,Bmp);
  if Variate1.Checked then variate;



end;

procedure TViswind.variate;
var
 A:Integer;
begin

 gl:=gl+gten;
 if gl=1 then gten:=gten*-1;;
 if gl=254 then gten:=gten*-1;

 rl:=rl+rten;
 if rl=1 then rten:=rten*-1;
 if rl=254 then rten:=rten*-1;

 bl:=bl+bten;
 if bl=1 then bten:=bten*-1;
 if bl=254 then bten:=bten*-1;

 kfc[10]:=kfc[10]+bten1;
 if kfc[10]=49 then kfc[10]:=50;
 if kfc[10]=59 then kfc[10]:=58;

 kfc1[10]:=kfc1[10]+gten1;
 if kfc1[10]=49 then kfc1[10]:=50;
 if kfc1[10]=59 then kfc1[10]:=58;

 kfc2[10]:=kfc2[10]+rten1;
 if kfc2[10]=179 then kfc2[10]:=180;
 if kfc2[10]=203 then kfc2[10]:=202;

 Kff1[10]:=Kff1[10]+rten1;
 if kff1[10]=39 then kff1[10]:=40;
 if kff1[10]=45 then kff1[10]:=44;

 kff2[10]:=kff2[10]+rten1;
 if kff2[10]=39 then kff2[10]:=40;
 if kff2[10]=45 then kff2[10]:=44;

 kff3[10]:=kff3[10]+rten1;
 if kff3[10]=39 then kff3[10]:=40;
 if kff3[10]=45 then kff3[10]:=44;

 kff4[10]:=kff4[10]+rten1;
 if kff4[10]=39 then kff4[10]:=40;
 if kff4[10]=45 then kff4[10]:=44;



 A:=Trunc(random*10);
 if A=5 then case trunc(random*6) of
               0:gten:=gten*-1;
               1:rten:=rten*-1;
               2:bten:=bten*-1;
               3:gten1:=gten1*-1;
               4:bten1:=bten1*-1;
               5:rten1:=rten1*-1;
              end;





end;

procedure TViswind.FormDestroy(Sender: TObject);
var
  Reg:TRegistry;
  i:Integer;
  DT:TTimeStamp;
begin
 Dt:=DateTimeToTimeStamp(Now);

// while (DateTimeToTimeStamp(Now).Time-Dt.Time)<5000 do;

  Bmp.Free;
  CloseHandle(fmap);
  for i:=1 to WaveArrCount do
   begin
   FreeMem(Warr[i])
   end;

  StrDispose(wtext);
  FreeMem(bmpinf,IHs);
{  FreeMem(bmpImg,Ims);
  FreeMem(RChannel);
  FreeMem(GChannel);
  FreeMem(BChannel);}

  {FreeMem(RChannel1);
  FreeMem(GChannel1);
  FreeMem(BChannel1);}

  FreeMem(RChannel2);
  FreeMem(GChannel2);
  FreeMem(BChannel2);


  Reg:=TRegistry.Create;
  if Reg.OpenKey(CfgKey,True) then
  begin
   Reg.WriteBool('RedBlur',Red1.Checked);
   Reg.WriteBool('GreenBlur',Green1.Checked);
   Reg.WriteBool('BlueBlur',Blue1.Checked);
   Reg.WriteBool('RedWaveform',Redwafveform1.Checked);
   Reg.WriteBool('GreenSpectrum',GreenSpectrum1.Checked);
   Reg.WriteBool('BlueSpaectrum',BlueSpectrum1.Checked);
   Reg.WriteBool('Variate',Variate1.Checked);
   Reg.WriteBool('SongName',SongName1.Checked);
   Reg.WriteBool('RunMasking',RunMasking1.Checked);
   if x11.Checked then Reg.WriteInteger('Size',1);
   if x21.Checked then Reg.WriteInteger('Size',2);
   if FullScreen1.Checked then Reg.WriteInteger('Size',3);
   if WinampLike1.Checked then Reg.WriteInteger('Size',4);
   REg.CloseKey;
  end;

 Reg.Free;
end;

procedure TViswind.FormKeyPress(Sender: TObject; var Key: Char);
begin
   if key=#27 then close;
   if key=#32 then Per:=200;
   if key='s' then bc:=7;
   if key='d' then bc:=6;
end;

procedure TViswind.Red1Click(Sender: TObject);
begin
  TMenuItem(Sender).Checked:= not TMenuItem(Sender).Checked;
end;

procedure TViswind.x21Click(Sender: TObject);
begin
 WindowState:=wsNormal;
 width:=512;
 height:=288;
 x21.Checked:=true;
end;

procedure TViswind.x11Click(Sender: TObject);
begin
 WindowState:=wsNormal;
 width:=256;
 height:=144;
 x11.Checked:=true;
end;


procedure TViswind.FullScreen1Click(Sender: TObject);
begin
  WindowState:=wsMaximized;
  FullScreen1.Checked:=true;
end;

function HkCallBack(code: Integer; wparam: WPARAM;
  lparam: LPARAM): LRESULT;
var
 Rect:TRect;
begin

end;

procedure TViswind.WinampLike1Click(Sender: TObject);
var
   R:Trect;
begin
 WinampLike1.Checked:=True;
 GetWindowRect(modulle.hwndParent,R);
 width:=R.Right-R.Left;
 Height:=r.Bottom-R.Top;
end;

end.
